gtkmm: Gtk::TreeModel Class Reference

# Gtk::TreeModel Class Reference
[TreeView Classes]

This class defines a generic tree interface for use by the Gtk::TreeView widget. More...

Inherits Glib::Interface.

Inherited by Gtk::ListStore, Gtk::TreeModelFilter, Gtk::TreeModelSort, and Gtk::TreeStore.

Collaboration diagram for Gtk::TreeModel:
[legend]

List of all members.

## Public Types
typedef TreeModelColumnRecord | ColumnRecord
typedef TreeNodeChildren | Children
typedef Children::iterator | iterator
typedef Children::reverse_iterator | reverse_iterator
typedef Children::const_iterator | const_iterator
typedef Children::const_reverse_iterator | const_reverse_iterator
typedef TreeRow | Row
typedef TreePath | Path
typedef TreeRowReference | RowReference
typedef sigc::slot< bool, const TreeModel::iterator& > | SlotForeachIter
| For example, void on_foreach(const Gtk::TreeModel::iterator& iter);.
typedef sigc::slot< bool, const TreeModel::Path& > | SlotForeachPath
| For example, void on_foreach(const Gtk::TreeModel::Path& path);.
typedef sigc::slot< bool, const TreeModel::Path&, const TreeModel::iterator& > | SlotForeachPathAndIter
| For example, void on_foreach(const Gtk::TreeModel::Path& path, const Gtk::TreeModel::iterator& iter);.
## Public Member Functions
virtual | ~TreeModel ()
GtkTreeModel* | gobj ()
| Provides access to the underlying C GObject.
const GtkTreeModel* | gobj () const
| Provides access to the underlying C GObject.
iterator | get_iter (const Path& path)
| Returns a valid iterator pointing to path.
iterator | get_iter (const Glib::ustring& path_string)
| Returns a valid iterator pointing to path_string.
Children | children ()
| This returns an STL-like container API, for iterating over the rows.
Children | children () const
| This returns an STL-like container API, for iterating over the rows.
void | foreach_iter (const SlotForeachIter& slot)
| Calls a callback slot on each node in the model in a depth-first fashion.
void | foreach_path (const SlotForeachPath& slot)
| Calls a callback slot on each node in the model in a depth-first fashion.
void | foreach (const SlotForeachPathAndIter& slot)
| Calls a callback slot on each node in the model in a depth-first fashion.
TreeModelFlags | get_flags () const
| Returns a set of flags supported by this interface.
int | get_n_columns () const
| Returns the number of columns supported by tree_model.
GType | get_column_type (int index) const
| Returns the type of the column.
TreeModel::Path | get_path (const iterator& iter) const
| Returns a Gtk::TreePath referenced by iter.
void | row_changed (const Path& path, const iterator& iter)
| Emits the "row-changed" signal on tree_model.
void | row_inserted (const Path& path, const iterator& iter)
| Emits the "row-inserted" signal on tree_model.
void | row_has_child_toggled (const Path& path, const iterator& iter)
| Emits the "row-has-child-toggled" signal on tree_model.
void | row_deleted (const Path& path)
| Emits the "row-deleted" signal on tree_model.
void | rows_reordered (const Path& path, const iterator& iter, const Glib::ArrayHandle< int >& new_order)
| Emits the "rows_reordered" signal on the tree model.
void | rows_reordered (const Path& path, const Glib::ArrayHandle< int >& new_order)
| Emits the "rows_reordered" signal on the tree model.
void | rows_reordered (const Path& path, const iterator& iter, int* new_order)
| Emits the "rows-reordered" signal on tree_model.
Glib::ustring | get_string (const iterator& iter) const
| Generates a string representation of the iter.
Glib::SignalProxy2< void, const TreeModel::Path&, const TreeModel::iterator& > | signal_row_changed ()
Glib::SignalProxy2< void, const TreeModel::Path&, const TreeModel::iterator& > | signal_row_inserted ()
Glib::SignalProxy2< void, const TreeModel::Path&, const TreeModel::iterator& > | signal_row_has_child_toggled ()
Glib::SignalProxy1< void, const TreeModel::Path& > | signal_row_deleted ()
Glib::SignalProxy3< void, const TreeModel::Path&, const TreeModel::iterator&, int* > | signal_rows_reordered ()
## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
## Protected Member Functions
virtual TreeModelFlags | get_flags_vfunc () const
virtual int | get_n_columns_vfunc () const
virtual GType | get_column_type_vfunc (int index) const
virtual bool | iter_next_vfunc (const iterator& iter, iterator& iter_next) const
| Override and implement this in a derived TreeModel class.
virtual bool | get_iter_vfunc (const Path& path, iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual bool | iter_children_vfunc (const iterator& parent, iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual bool | iter_parent_vfunc (const iterator& child, iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual bool | iter_nth_child_vfunc (const iterator& parent, int n, iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual bool | iter_nth_root_child_vfunc (int n, iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual bool | iter_has_child_vfunc (const iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual int | iter_n_children_vfunc (const iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual int | iter_n_root_children_vfunc () const
| Override and implement this in a derived TreeModel class.
virtual void | ref_node_vfunc (const iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual void | unref_node_vfunc (const iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual TreeModel::Path | get_path_vfunc (const iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual void | get_value_vfunc (const iterator& iter, int column, Glib::ValueBase&value) const
| Override and implement this in a derived TreeModel class.
virtual bool | iter_is_valid (const iterator& iter) const
| Override and implement this in a derived TreeModel class.
virtual void | set_value_impl (const iterator& row, int column, const Glib::ValueBase&value)
| Override and implement this in a derived TreeModel class, so that Row::operator() and Row::set_value() work.
virtual void | get_value_impl (const iterator& row, int column, Glib::ValueBase&value) const
virtual void | on_row_changed (const TreeModel::Path& path, const TreeModel::iterator& iter)
virtual void | on_row_inserted (const TreeModel::Path& path, const TreeModel::iterator& iter)
virtual void | on_row_has_child_toggled (const TreeModel::Path& path, const TreeModel::iterator& iter)
virtual void | on_row_deleted (const TreeModel::Path& path)
virtual void | on_rows_reordered (const TreeModel::Path& path, const TreeModel::iterator& iter, int* new_order)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::TreeModel > | wrap (GtkTreeModel* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

This class defines a generic tree interface for use by the Gtk::TreeView widget.

It is is designed to be usable with any appropriate data structure. The programmer just has to implement this interface on their own data type for it to be viewable by a Gtk::TreeView widget.

The model is represented as a hierarchical tree of strongly-typed, columned data. In other words, the model can be seen as a tree where every node has different values depending on which column is being queried. The type of data found in a column is determined by TreeModel::Column<> templates. The types are homogeneous per column across all nodes. It is important to note that this interface only provides a way of examining a model and observing changes. The implementation of each individual model decides how and if changes are made.

In order to make life simpler for programmers who do not need to write their own specialized model, two generic models are provided - the Gtk::TreeStore and the Gtk::ListStore. To use these, the developer simply pushes data into these models as necessary. These models provide the data structure as well as all appropriate tree interfaces. As a result, implementing drag and drop, sorting, and storing data is trivial. For the vast majority of trees and lists, these two models are sufficient.

Models are accessed on a node/column level of granularity. One can query for the value of a model at a certain node and a certain column on that node. There are two structures used to reference a particular node in a model. They are the Path and the iterator. Most of the interface consists of operations on an iterator.

A Gtk::TreeModel::Path is essentially a potential node. It is a location on a model that may or may not actually correspond to a node on a specific model.

By contrast, an Gtk::TreeModel::iterator is a reference to a specific node on a specific model. One can convert a path to an iterator by calling Gtk::TreeModel::get_iter(). These iterators are the primary way of accessing a model and are similar to the iterators used by Gtk::TextBuffer. The model interface defines a set of operations using them for navigating the model.

The RowReference is also useful, because it remains valid as long as there is an existing row pointed to by it's path. You can convert between RowReferences and iterators and Path s.

## Member Typedef Documentation

typedef TreeNodeChildren Gtk::TreeModel::Children

typedef TreeModelColumnRecord Gtk::TreeModel::ColumnRecord

typedef Children::const_iterator Gtk::TreeModel::const_iterator

typedef Children::const_reverse_iterator Gtk::TreeModel::const_reverse_iterator

typedef Children::iterator Gtk::TreeModel::iterator

typedef TreePath Gtk::TreeModel::Path

typedef Children::reverse_iterator Gtk::TreeModel::reverse_iterator

typedef TreeRow Gtk::TreeModel::Row

typedef TreeRowReference Gtk::TreeModel::RowReference

typedef sigc::slot<bool, const TreeModel::iterator&> Gtk::TreeModel::SlotForeachIter

For example, void on_foreach(const Gtk::TreeModel::iterator& iter);.

If the callback function returns true, then the tree ceases to be walked, and foreach() returns.

typedef sigc::slot<bool, const TreeModel::Path&> Gtk::TreeModel::SlotForeachPath

For example, void on_foreach(const Gtk::TreeModel::Path& path);.

If the callback function returns true, then the tree ceases to be walked, and foreach() returns.

typedef sigc::slot<bool, const TreeModel::Path&, const TreeModel::iterator&> Gtk::TreeModel::SlotForeachPathAndIter

For example, void on_foreach(const Gtk::TreeModel::Path& path, const Gtk::TreeModel::iterator& iter);.

If the callback function returns true, then the tree ceases to be walked, and foreach() returns.

## Constructor & Destructor Documentation

virtual Gtk::TreeModel::~TreeModel | ( |  | ) | `[virtual]`

## Member Function Documentation

static void Gtk::TreeModel::add_interface | ( | GType | gtype_implementer | ) | `[static]`

Children Gtk::TreeModel::children | ( |  | ) | const

This returns an STL-like container API, for iterating over the rows.

Children Gtk::TreeModel::children | ( |  | ) |

This returns an STL-like container API, for iterating over the rows.

void Gtk::TreeModel::foreach | ( | const SlotForeachPathAndIter & | slot | ) |

Calls a callback slot on each node in the model in a depth-first fashion.

If the callback function returns true, then the tree ceases to be walked, and foreach() returns.

Parameters:

  | slot | The function to call for each selected node.

void Gtk::TreeModel::foreach_iter | ( | const SlotForeachIter & | slot | ) |

Calls a callback slot on each node in the model in a depth-first fashion.

If the callback function returns true, then the tree ceases to be walked, and foreach() returns.

Parameters:

  | slot | The function to call for each selected node.

void Gtk::TreeModel::foreach_path | ( | const SlotForeachPath & | slot | ) |

Calls a callback slot on each node in the model in a depth-first fashion.

If the callback function returns true, then the tree ceases to be walked, and foreach() returns.

Parameters:

  | slot | The function to call for each selected node.

GType Gtk::TreeModel::get_column_type | ( | int | index | ) | const

Returns the type of the column.

Parameters:

  | index | The column index.

Returns:
  The type of the column.

virtual GType Gtk::TreeModel::get_column_type_vfunc | ( | int | index | ) | const`[protected, virtual]`

TreeModelFlags Gtk::TreeModel::get_flags | ( |  | ) | const

Returns a set of flags supported by this interface.

The flags are a bitwise combination of Gtk::TreeModelFlags. The flags supported should not change during the lifecycle of the tree_model.

Returns:
  The flags supported by this interface.

virtual TreeModelFlags Gtk::TreeModel::get_flags_vfunc | ( |  | ) | const`[protected, virtual]`

iterator Gtk::TreeModel::get_iter | ( | const Glib::ustring & | path_string | ) |

Returns a valid iterator pointing to path_string.

Parameters:

  | path_string | The path, as a string representation.

Returns:
  A valid iterator pointing to the path, or an invalid iterator if that is not possible.

iterator Gtk::TreeModel::get_iter | ( | const Path& | path | ) |

Returns a valid iterator pointing to path.

Parameters:

  | path | The Gtk::TreeModel::Path.

Returns:
  A valid iterator pointing to the path, or an invalid iterator if that is not possible.

virtual bool Gtk::TreeModel::get_iter_vfunc | ( | const Path& | path,
|  | iterator& | iter |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Sets iter to a valid iterator pointing to path

Parameters:

  | path | An path to a node.
  | iter | An iterator that will be set to refer to a node to the path, or will be set as invalid.

Returns:
  true if the operation was possible.

int Gtk::TreeModel::get_n_columns | ( |  | ) | const

Returns the number of columns supported by tree_model.

Returns:
  The number of columns.

virtual int Gtk::TreeModel::get_n_columns_vfunc | ( |  | ) | const`[protected, virtual]`

TreeModel::Path Gtk::TreeModel::get_path | ( | const iterator& | iter | ) | const

Returns a Gtk::TreePath referenced by iter.

Parameters:

  | iter | The Gtk::TreeIter.

Returns:
  A Gtk::TreePath.

virtual TreeModel::Path Gtk::TreeModel::get_path_vfunc | ( | const iterator& | iter | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Returns a Path referenced by iter.

Parameters:

  | iter | The iterator.

Returns:
  The path.

Glib::ustring Gtk::TreeModel::get_string | ( | const iterator& | iter | ) | const

Generates a string representation of the iter.

This string is a ':' separated list of numbers. For example, "4:10:0:3" would be an acceptable return value for this string.

Since gtkmm 2.2:

Parameters:

  | iter | An Gtk::TreeIter.

Returns:
  The string.

virtual void Gtk::TreeModel::get_value_impl | ( | const iterator& | row,
|  | int | column,
|  | Glib::ValueBase & | value |
| ) |  |  | const`[protected, virtual]`

virtual void Gtk::TreeModel::get_value_vfunc | ( | const iterator& | iter,
|  | int | column,
|  | Glib::ValueBase & | value |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Initializes and sets value to that at column.

Parameters:

  | iter | The iterator.
  | column | The column to lookup the value at.
  | value | An empty Glib:Value to set.

const GtkTreeModel* Gtk::TreeModel::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gtk::ListStore, Gtk::TreeModelFilter, Gtk::TreeModelSort, and Gtk::TreeStore.

GtkTreeModel* Gtk::TreeModel::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gtk::ListStore, Gtk::TreeModelFilter, Gtk::TreeModelSort, and Gtk::TreeStore.

virtual bool Gtk::TreeModel::iter_children_vfunc | ( | const iterator& | parent,
|  | iterator& | iter |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Sets iter to refer to the first child of parent. If parent has no children, false is returned and iter is set to be invalid.

Parameters:

  | parent | An iterator.
  | iter | An iterator that will be set to refer to the firt child node, or will be set as invalid.

Returns:
  true if the operation was possible.

virtual bool Gtk::TreeModel::iter_has_child_vfunc | ( | const iterator& | iter | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Returns true if iter has children, false otherwise.

Parameters:

  | iter | The iterator to test for children.

Returns:
  true if iter has children.

virtual bool Gtk::TreeModel::iter_is_valid | ( | const iterator& | iter | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Note:
  This virtual method is not recommended. To check whether an iterator is valid, call TreeStore::iter_is_valid(), ListStore::iter_is_valid() or TreeModelSort::iter_is_valid() directly instead. Because these methods are intended to be used only for debugging and/or testing purposes, it doesn't make sense to provide an abstract interface to them.

Returns:
  true if the iterator is valid.

Deprecated:
  Use iter_is_valid() in the derived class.

Reimplemented in Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

virtual int Gtk::TreeModel::iter_n_children_vfunc | ( | const iterator& | iter | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Returns the number of children that iter has. See also iter_n_root_children_vfunc().

Parameters:

  | iter | The iterator to test for children.

Returns:
  The number of children of iter.

virtual int Gtk::TreeModel::iter_n_root_children_vfunc | ( |  | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Returns the number of toplevel nodes. See also iter_n_children().

Returns:
  The number of children at the root level.

virtual bool Gtk::TreeModel::iter_next_vfunc | ( | const iterator& | iter,
|  | iterator& | iter_next |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Sets iter_next to refer to the node following iter it at the current level. If there is no next iter, false is returned and iter_next is set to be invalid.

Parameters:

  | iter | An iterator.
  | iter_next | An iterator that will be set to refer to the next node, or will be set as invalid.

Returns:
  true if the operation was possible.

virtual bool Gtk::TreeModel::iter_nth_child_vfunc | ( | const iterator& | parent,
|  | int | n,
|  | iterator& | iter |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Sets iter to be the child of parent using the given index. The first index is 0. If n is too big, or parent has no children, iter is set to an invalid iterator and false is returned. See also iter_nth_root_child_vfunc()

Parameters:

  | parent | An iterator.
  | n | The index of the child node to which iter should be set.
  | iter | An iterator that will be set to refer to the nth node, or will be set as invalid.

Returns:
  true if the operation was possible.

virtual bool Gtk::TreeModel::iter_nth_root_child_vfunc | ( | int | n,
|  | iterator& | iter |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Sets iter to be the child of at the root level using the given index. The first index is 0. If n is too big, or if there are no children, iter is set to an invalid iterator and false is returned. See also iter_nth_child_vfunc().

Parameters:

  | n | The index of the child node to which iter should be set.
  | iter | An iterator that will be set to refer to the nth node, or will be set as invalid.

Returns:
  true if the operation was possible.

virtual bool Gtk::TreeModel::iter_parent_vfunc | ( | const iterator& | child,
|  | iterator& | iter |
| ) |  |  | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Sets iter to be the parent of child. If child is at the toplevel, and doesn't have a parent, then iter is set to an invalid iterator and false is returned.

Parameters:

  | child | An iterator.
  | iter | An iterator that will be set to refer to the parent node, or will be set as invalid.

Returns:
  true if the operation was possible.

virtual void Gtk::TreeModel::on_row_changed | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_deleted | ( | const TreeModel::Path& | path | ) | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_has_child_toggled | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_inserted | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TreeModel::on_rows_reordered | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter,
|  | int * | new_order |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TreeModel::ref_node_vfunc | ( | const iterator& | iter | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Lets the tree ref the node. This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons.

This function is primarily meant as a way for views to let caching model know when nodes are being displayed (and hence, whether or not to cache that node.) For example, a file-system based model would not want to keep the entire file-hierarchy in memory, just the sections that are currently being displayed by every current view.

A model should be expected to be able to get an iter independent of its reffed state.

Parameters:

  | iter | the iterator.

void Gtk::TreeModel::row_changed | ( | const Path& | path,
|  | const iterator& | iter |
| ) |  |  |

Emits the "row-changed" signal on tree_model.

Parameters:

  | path | A Gtk::TreePath pointing to the changed row.
  | iter | A valid Gtk::TreeIter pointing to the changed row.

void Gtk::TreeModel::row_deleted | ( | const Path& | path | ) |

Emits the "row-deleted" signal on tree_model.

This should be called by models after a row has been removed. The location pointed to by path should be the location that the row previously was at. It may not be a valid location anymore.

Parameters:

  | path | A Gtk::TreePath pointing to the previous location of the deleted row.

void Gtk::TreeModel::row_has_child_toggled | ( | const Path& | path,
|  | const iterator& | iter |
| ) |  |  |

Emits the "row-has-child-toggled" signal on tree_model.

This should be called by models after the child state of a node changes.

Parameters:

  | path | A Gtk::TreePath pointing to the changed row.
  | iter | A valid Gtk::TreeIter pointing to the changed row.

void Gtk::TreeModel::row_inserted | ( | const Path& | path,
|  | const iterator& | iter |
| ) |  |  |

Emits the "row-inserted" signal on tree_model.

Parameters:

  | path | A Gtk::TreePath pointing to the inserted row.
  | iter | A valid Gtk::TreeIter pointing to the inserted row.

void Gtk::TreeModel::rows_reordered | ( | const Path& | path,
|  | const iterator& | iter,
|  | int * | new_order |
| ) |  |  |

Emits the "rows-reordered" signal on tree_model.

This should be called by models when their rows have been reordered.

Parameters:

  | path | A Gtk::TreePath pointing to the tree node whose children have been reordered.
  | iter | A valid Gtk::TreeIter pointing to the node whose children have been reordered, or `0` if the depth of path is 0.
  | new_order | An array of integers mapping the current position of each child to its old position before the re-ordering, i.e. new_order<literal>[newpos] = oldpos</literal>.

void Gtk::TreeModel::rows_reordered | ( | const Path& | path,
|  | const Glib::ArrayHandle< int > & | new_order |
| ) |  |  |

Emits the "rows_reordered" signal on the tree model.

This should be called by custom models when their rows have been reordered. This method overload is for nodes whose path has a depth of 0.

Since gtkmm 2.10:

Parameters:

  | path | A tree path pointing to the tree node whose children have been reordered.
  | new_order | An array of integers mapping the current position of each child to its old position before the re-ordering, i.e. new_order<literal>[newpos] = oldpos.

void Gtk::TreeModel::rows_reordered | ( | const Path& | path,
|  | const iterator& | iter,
|  | const Glib::ArrayHandle< int > & | new_order |
| ) |  |  |

Emits the "rows_reordered" signal on the tree model.

This should be called by custom models when their rows have been reordered.

Parameters:

  | path | A tree path pointing to the tree node whose children have been reordered.
  | iter | A valid iterator pointing to the node whose children have been reordered. See also, rows_reordered(const Path& path, const Glib::ArrayHandle<int>& new_order), if the path has a depth of 0.
  | new_order | An array of integers mapping the current position of each child to its old position before the re-ordering, i.e. new_order<literal>[newpos] = oldpos.

virtual void Gtk::TreeModel::set_value_impl | ( | const iterator& | row,
|  | int | column,
|  | const Glib::ValueBase & | value |
| ) |  |  | `[protected, virtual]`

Override and implement this in a derived TreeModel class, so that Row::operator() and Row::set_value() work.

You can probably just implement this by calling set_value_vfunc(). Your implementation of set_value_impl() should also call row_changed() after changing the value.

Reimplemented in Gtk::ListStore, Gtk::TreeModelFilter, Gtk::TreeModelSort, and Gtk::TreeStore.

Glib::SignalProxy2< void,const TreeModel::Path&,const TreeModel::iterator& > Gtk::TreeModel::signal_row_changed | ( |  | ) |

Prototype:
  `void on_my_row_changed(const TreeModel::Path& path, const TreeModel::iterator& iter)`

Glib::SignalProxy1< void,const TreeModel::Path& > Gtk::TreeModel::signal_row_deleted | ( |  | ) |

Prototype:
  `void on_my_row_deleted(const TreeModel::Path& path)`

Glib::SignalProxy2< void,const TreeModel::Path&,const TreeModel::iterator& > Gtk::TreeModel::signal_row_has_child_toggled | ( |  | ) |

Prototype:
  `void on_my_row_has_child_toggled(const TreeModel::Path& path, const TreeModel::iterator& iter)`

Glib::SignalProxy2< void,const TreeModel::Path&,const TreeModel::iterator& > Gtk::TreeModel::signal_row_inserted | ( |  | ) |

Prototype:
  `void on_my_row_inserted(const TreeModel::Path& path, const TreeModel::iterator& iter)`

Glib::SignalProxy3< void,const TreeModel::Path&,const TreeModel::iterator&,int* > Gtk::TreeModel::signal_rows_reordered | ( |  | ) |

Prototype:
  `void on_my_rows_reordered(const TreeModel::Path& path, const TreeModel::iterator& iter, int* new_order)`

virtual void Gtk::TreeModel::unref_node_vfunc | ( | const iterator& | iter | ) | const`[protected, virtual]`

Override and implement this in a derived TreeModel class.

Lets the tree unref the node. This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons.

For more information on what this means, see unref_node_vfunc(). Please note that nodes that are deleted are not unreffed.

Parameters:

  | iter | the iterator.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::TreeModel > wrap | ( | GtkTreeModel * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/treemodel.h